

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../../../_static/doctools.js"></script>
        <script type="text/javascript" src="../../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../contributing.html">Contributing</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../documentation.html">Backend documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
        
      <li>SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler</h1><div class="highlight"><pre>
<span></span><span class="ch">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># License : GNU General Public License</span>
<span class="c1"># Authors: Romain Guillot, Alicia</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">TODO: Not yet review.</span>
<span class="sd">TODO/ finish to do the documentation</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">import</span> <span class="nn">csv</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd</span> <span class="k">import</span> <span class="n">app</span>


<div class="viewcode-block" id="add_offer_to_database"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_offer_to_database">[docs]</a><span class="k">def</span> <span class="nf">add_offer_to_database</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">offer</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Add one preprocessed offer in the database</span>

<span class="sd">    :param db_manager: database manager</span>
<span class="sd">    :type: DatabaseManager</span>

<span class="sd">    :param offer: list of (text,descriptor,label)</span>
<span class="sd">    :rtype offer:</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">admin_id</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">get_one_admin</span><span class="p">()</span><span class="o">.</span><span class="n">id</span>
    <span class="n">name_field</span> <span class="o">=</span> <span class="n">offer</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">id_offer</span> <span class="o">=</span> <span class="n">add_an_offer</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">offer</span><span class="p">,</span> <span class="n">admin_id</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">id_offer</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span><span class="p">:</span>
        <span class="n">id_field</span> <span class="o">=</span> <span class="n">get_id_field</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">name_field</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">id_field</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span><span class="p">:</span>
            <span class="n">db_manager</span><span class="o">.</span><span class="n">prediction_manager</span><span class="o">.</span><span class="n">add_prediction</span><span class="p">(</span><span class="mf">100.0</span><span class="p">,</span> <span class="n">id_field</span><span class="p">,</span> <span class="n">id_offer</span><span class="p">,</span> <span class="kc">True</span><span class="p">)</span></div>


<div class="viewcode-block" id="add_an_offer"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_an_offer">[docs]</a><span class="k">def</span> <span class="nf">add_an_offer</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">offer</span><span class="p">,</span> <span class="n">id_admin</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Add a preprocessed offer in the database</span>

<span class="sd">    :param offer: (text,descriptor,label) the processed offer</span>
<span class="sd">    :type:</span>

<span class="sd">    :param db_manager: database manager</span>
<span class="sd">    :type db_manager: DatabaseManager</span>

<span class="sd">    :param id_admin;</span>
<span class="sd">    :type:</span>

<span class="sd">    :return the id of the newly created offer</span>
<span class="sd">    :rtype int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Make title</span>
    <span class="n">title</span> <span class="o">=</span> <span class="n">offer</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39; &#39;</span><span class="p">)</span>
    <span class="n">title</span> <span class="o">=</span> <span class="n">title</span><span class="p">[:</span><span class="mi">5</span><span class="p">]</span>
    <span class="n">title</span> <span class="o">=</span> <span class="s1">&#39; &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">title</span><span class="p">)</span>

    <span class="n">_id</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">add_offer_v2</span><span class="p">(</span><span class="n">title</span><span class="p">,</span> <span class="n">offer</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">id_admin</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">_id</span></div>


<div class="viewcode-block" id="get_id_field"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.get_id_field">[docs]</a><span class="k">def</span> <span class="nf">get_id_field</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Add id of the named field or create the field and get the id if the field doesn&#39;t exist</span>

<span class="sd">    :param db_manager: database manager</span>
<span class="sd">    :type db_manager: DatabaseManager</span>

<span class="sd">    :param name: name of the field</span>
<span class="sd">    :type name: str</span>

<span class="sd">    :return: id of the offer if successful, -1 if not</span>
<span class="sd">    :rtype: int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">field</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_by_name</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">field</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">field</span><span class="o">.</span><span class="n">id</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">_id</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">add_field_v2</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">_id</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">_id</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="o">-</span><span class="mi">1</span></div>


<div class="viewcode-block" id="set_field_information"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.set_field_information">[docs]</a><span class="k">def</span> <span class="nf">set_field_information</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">description</span><span class="p">,</span> <span class="n">website</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Set information for the field name</span>

<span class="sd">    :param db_manager</span>
<span class="sd">    :param name : name of the field to update</span>
<span class="sd">    :param description</span>
<span class="sd">    :param website</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">_id</span> <span class="o">=</span> <span class="n">get_id_field</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span>
    <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">update_field</span><span class="p">(</span><span class="n">_id</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">description</span><span class="p">,</span> <span class="n">website</span><span class="p">)</span></div>


<span class="k">def</span> <span class="nf">add_fields</span><span class="p">(</span><span class="n">db_manager</span><span class="p">):</span>
    <span class="n">filename</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;fields_dataset&quot;</span><span class="p">]</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">reader</span> <span class="o">=</span> <span class="n">csv</span><span class="o">.</span><span class="n">DictReader</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">row</span> <span class="ow">in</span> <span class="n">reader</span><span class="p">:</span>
            <span class="n">set_field_information</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">],</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;description&#39;</span><span class="p">],</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;website&#39;</span><span class="p">])</span>


<div class="viewcode-block" id="add_contact"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_contact">[docs]</a><span class="k">def</span> <span class="nf">add_contact</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">field_name</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">surname</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">email</span><span class="p">,</span> <span class="n">phone</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Insert contact in the database</span>

<span class="sd">    :param db_manager</span>
<span class="sd">    :param field_name</span>
<span class="sd">    :param name</span>
<span class="sd">    :param surname</span>
<span class="sd">    :param role</span>
<span class="sd">    :param email</span>
<span class="sd">    :param phone</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">id_field</span> <span class="o">=</span> <span class="n">get_id_field</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">field_name</span><span class="p">)</span>
    <span class="n">db_manager</span><span class="o">.</span><span class="n">contact_manager</span><span class="o">.</span><span class="n">add_contact</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">surname</span><span class="p">,</span> <span class="n">email</span><span class="p">,</span> <span class="n">phone</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">id_field</span><span class="p">)</span></div>


<div class="viewcode-block" id="add_contacts"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_contacts">[docs]</a><span class="k">def</span> <span class="nf">add_contacts</span><span class="p">(</span><span class="n">db_manager</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">    :param db_manager: database_manager</span>
<span class="sd">    :type db_manager: DatabaseManager</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">filename</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;contacts_dataset&quot;</span><span class="p">]</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">reader</span> <span class="o">=</span> <span class="n">csv</span><span class="o">.</span><span class="n">DictReader</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">row</span> <span class="ow">in</span> <span class="n">reader</span><span class="p">:</span>
            <span class="n">add_contact</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;field&#39;</span><span class="p">],</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">],</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;surname&#39;</span><span class="p">],</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;role&#39;</span><span class="p">],</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;email&#39;</span><span class="p">],</span> <span class="n">row</span><span class="p">[</span><span class="s1">&#39;phone&#39;</span><span class="p">])</span></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>